/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/
package jp.co.ntt.lms.installer.lms;

import java.io.File;
import java.util.Properties;
import java.util.logging.Logger;

import jp.co.ntt.lms.installer.core.InstallerAction;
import jp.co.ntt.lms.installer.core.InstallerActionValue;
import jp.co.ntt.lms.installer.core.InstallerException;
import jp.co.ntt.lms.installer.core.InstallerValues;
import jp.co.ntt.lms.installer.core.util.InstallerPropertiesUtil;
import jp.co.ntt.lms.installer.core.util.InstallerUiUtil;
import jp.co.ntt.lms.installer.util.FileUtil;
import jp.co.ntt.lms.installer.util.LoggerUtil;

/**
 * メール設定ファイルの書換項目について入力を求めるアクションクラス。
 * @author T.Nishiki
 */
public class MailInputAction implements InstallerAction {
	/**
	 * ログ出力オブジェクト。
	 */
	private static Logger _logger;

	/**
	 * スタティック・イニシャライザ。
	 */
	static {
		_logger = LoggerUtil.getLogger(MailInputAction.class);
	}

	/**
	 * アクションをスキップするか判定します。<br>
	 * スキップしないのでfalseを戻します。<br>
	 *
	 * @param values インストーラ共通データ・オブジェクト。
	 * @return falseを戻します。
	 */
	public boolean isSkipped(InstallerValues values) {
		return false;
	}

	/**
	 * メール設定ファイルの書換項目について入力・確認を求めます。<br>
	 *
	 * @param values インストーラ共通データ・オブジェクト。
	 * @return MailInputValueを戻します。
	 * @throws InstallerException 実行中に例外が発生した場合。
	 * @see MailInputValue
	 */
	public InstallerActionValue action(InstallerValues values)
		throws InstallerException {

		LoggerUtil.methodHead(_logger, "action(InstallerValues)");
		// 今回入力データ
		MailInputValue inputValue = null;
		try {
			// 既存入力データ（デフォルトデータとして使用）
			MailInputValue defaultValue = getDefaultValue(values);
			// タイトルの表示
			InstallerUiUtil.outputMessageAsTitle(
				values, "MailInputAction.welcome");

			while (true) {
				// 入力実行
				inputValue = readInputValue(values, defaultValue);
				// 入力確認
				if (confirmInputValue(values, inputValue) == true) {
					break;
				}
			}
		}
		catch (InstallerException e) {
			throw e;
		}
		catch (Exception e) {
			LoggerUtil.throwable(_logger, e);
			throw new InstallerException(e);
		}

		LoggerUtil.methodTail(_logger, "action(InstallerValues)", inputValue);
		return inputValue;
	}

	/**
	 * マネージャ設定ファイルの書換項目について入力を求めます。<br>
	 *
	 * @param values インストーラ共通データ・オブジェクト。
	 * @param defaultValue デフォルト値。
	 * @return 入力された内容をMailInputValueを戻します。
	 * @throws InstallerException 実行中に例外が発生した場合。
	 */
	private MailInputValue readInputValue(
			InstallerValues values, MailInputValue defaultValue)
			throws InstallerException {
		LoggerUtil.methodHead(_logger,
			"readInputValue(InstallerValues," + defaultValue + ")");

		MailInputValue inputValue = null;
		try {
			inputValue = new MailInputValue();
			// =================================================================
			// SMTPホスト
			String smtpHost = InstallerUiUtil.askUserInput(values,
					"MailInputAction.prompt.smtpHost",
					defaultValue.getSmtpHost());
			inputValue.setSmtpHost(smtpHost);
			// =================================================================
			// SMTPポート番号
			String smtpPort = InstallerUiUtil.askUserInput(values,
					"MailInputAction.prompt.smtpPort",
					defaultValue.getSmtpPort());
			inputValue.setSmtpPort(smtpPort);
			// =================================================================
			// 送信元メールアドレス
			String mailFrom = InstallerUiUtil.askUserInput(values,
					"MailInputAction.prompt.mailFrom",
					defaultValue.getMailFrom());
			inputValue.setMailFrom(mailFrom);
			// =================================================================
			// サイト管理者メールアドレス
			String administratorMail = InstallerUiUtil.askUserInput(values,
					"MailInputAction.prompt.siteAdministratorMail",
					defaultValue.getSiteAdministratorMail());
			inputValue.setSiteAdministratorMail(administratorMail);
			// =================================================================
			// サイト管理用メールアドレス
			String siteMailerMail = InstallerUiUtil.askUserInput(values,
					"MailInputAction.prompt.siteMailerMail",
					defaultValue.getSiteMailerMail());
			inputValue.setSiteMailerMail(siteMailerMail);
			// =================================================================
			// ヘルプデスク用メールアドレス
			String helpdeskMail = InstallerUiUtil.askUserInput(values,
					"MailInputAction.prompt.helpdeskMail",
					defaultValue.getHelpdeskMail());
			inputValue.setHelpdeskMail(helpdeskMail);
		}
		catch (InstallerException e) {
			throw e;
		}
		catch (Exception e) {
			LoggerUtil.throwable(_logger, e);
			throw new InstallerException(e);
		}

		LoggerUtil.methodTail(_logger,
			"readInputValue(InstallerValues,MailInputValue)", inputValue);
		return inputValue;
	}

	/**
	 * 入力した内容を表示し、ユーザに確認を求めます。<br>
	 * @param values インストーラ共通データ・オブジェクト。
	 * @param inputValue 入力された内容
	 * @return 入力された内容にユーザ確認がとれた場合true、
	 *          とれなかった場合falseを戻します。
	 * @throws InstallerException 処理中にエラーが発生した場合。
	 */
	private boolean confirmInputValue(
			InstallerValues values, MailInputValue inputValue)
			throws InstallerException {

		LoggerUtil.methodHead(_logger,
			"confirmInputValue(InstallerValues, MailInputValue)");
		boolean confirm = false;
		try {
			InstallerUiUtil.outputConfirmTitle(values,
				"MailInputAction.confirm.title");
			// =================================================================
			// 入力内容の表示
			// =================================================================
			// SMTPホスト
			InstallerUiUtil.outputConfirm(values,
				"MailInputAction.confirm.smtpHost",
				inputValue.getSmtpHost());
			// SMTPポート番号
			InstallerUiUtil.outputConfirm(values,
				"MailInputAction.confirm.smtpPort",
				inputValue.getSmtpPort());
			// 送信元メールアドレス
			InstallerUiUtil.outputConfirm(values,
				"MailInputAction.confirm.mailFrom",
				inputValue.getMailFrom());
			// サイト管理者用メールアドレス
			InstallerUiUtil.outputConfirm(values,
				"MailInputAction.confirm.siteAdministratorMail",
				inputValue.getSiteAdministratorMail());
			// サイト管理者メールアドレス
			InstallerUiUtil.outputConfirm(values,
				"MailInputAction.confirm.siteMailerMail",
				inputValue.getSiteMailerMail());
			// ヘルプデスク・メールアドレス
			InstallerUiUtil.outputConfirm(values,
				"MailInputAction.confirm.helpdeskMail",
				inputValue.getHelpdeskMail());
			// =================================================================
			// ユーザ確認
			confirm = InstallerUiUtil.askUserConfirm(
				values, "MailInputAction.confirm" );
		}
		catch (InstallerException e) {
			throw e;
		}
		catch (Exception e) {
			LoggerUtil.throwable(_logger, e);
			throw new InstallerException(e);
		}

		LoggerUtil.methodTail(_logger,
			"confirmInputValue(InstallerValues, MailInputValue)", confirm);
		return confirm;
	}

	/**
	 * 既存のデータから、入力項目のデフォルト値を取得します。<br>
	 * @param values インストーラ共通データ・オブジェクト。
	 * @return デフォルト値をMailInputValueの形で戻します。
	 * @throws InstallerException 実行中に例外が発生した場合。
	 */
	private MailInputValue getDefaultValue(InstallerValues values)
			throws InstallerException {
		// メソッド開始ログ
		LoggerUtil.methodHead(_logger,
			"getDefaultValue(InstallerValues)");

		MailInputValue defaultValue = null;
		try {
			defaultValue = new MailInputValue();
			////////////////////////////////////////////////////////////////////
			// プロパティの取得
			// =================================================================
			// 既存の内容
			File existFile = values.getFileOnSystem(
					defaultValue.getTargetFileKey());
			Properties existProperties
				= FileUtil.loadAsProperties(existFile);
			// =================================================================
			// リソース（原本）の内容
			Properties resourceProperties
				= InstallerPropertiesUtil.load(
						values, defaultValue.getTargetFileKey());
			////////////////////////////////////////////////////////////////////
			// デフォルト値の設定
			// =================================================================
			// SMTPホスト
			String smtpHost = InstallerPropertiesUtil.determineInitialValue(
								existProperties, resourceProperties,
								MailInputValue.KEY_SMTP_HOST);
			defaultValue.setSmtpHost(smtpHost);
			// =================================================================
			// SMTPポート番号
			String smtpPort = InstallerPropertiesUtil.determineInitialValue(
								existProperties, resourceProperties,
								MailInputValue.KEY_SMTP_PORT);
			defaultValue.setSmtpPort(smtpPort);
			// =================================================================
			// 送信元メールアドレス
			String mailFrom = InstallerPropertiesUtil.determineInitialValue(
								existProperties, resourceProperties,
								MailInputValue.KEY_MAIL_FROM);
			defaultValue.setMailFrom(mailFrom);
			// =================================================================
			// サイト管理者用メールアドレス
			String siteAdministratorMail
				= InstallerPropertiesUtil.determineInitialValue(
					existProperties, resourceProperties,
					MailInputValue.KEY_SITE_ADMINISTRATOR_MAIL);
			defaultValue.setSiteAdministratorMail(siteAdministratorMail);
			// =================================================================
			// サイト管理用メールアドレス
			String siteMailerMail
				= InstallerPropertiesUtil.determineInitialValue(
					existProperties, resourceProperties,
					MailInputValue.KEY_SITE_MAILER_MAIL);
			defaultValue.setSiteMailerMail(siteMailerMail);
			// =================================================================
			// データベース・エンコード
			String helpdeskMail = InstallerPropertiesUtil.determineInitialValue(
								existProperties, resourceProperties,
								MailInputValue.KEY_HELPDESK_MAIL);
			defaultValue.setHelpdeskMail(helpdeskMail);
		}
		catch (InstallerException e) {
			throw e;
		}
		catch (Exception e) {
			LoggerUtil.throwable(_logger, e);
			throw new InstallerException(e);
		}
		// メソッド終了ログ
		LoggerUtil.methodTail(_logger,
			"getDefaultValue(InstallerValues)", defaultValue);
		return defaultValue;
	}
}
